#include <YoggieEngine.h>
#include "Camera.h"
namespace YoggieEngine {
	Camera::Camera(const Camera& other) 
		: Position(other.Position), Rotation(other.Rotation), Zoom(other.Zoom)
	{
		
	}
	Camera::Camera(glm::vec3 position, glm::vec3 rotation, float zoom) 
		: Position(position), Rotation( rotation)
	{
		Front = glm::vec3(0.0f, 0.0f, 1.0f);
		Right = glm::vec3(-1.0f, 0.0f, 0.0f);
		Up = glm::vec3(0.0f, 1.0f, 0.0f);
		Zoom = zoom;

		ProjectionMatrix = glm::perspective(glm::radians(Zoom), (800.0f / 600.0f), 0.001f, 100.0f);
		Update();
	
	}

	Camera::~Camera() {

	}

	void Camera::Update() {
		glm::vec3 WorldUp = glm::vec3(0.0f, 1.0f, 0.0f);
	
		glm::vec3(direction);


		direction.x = cos(glm::radians(yaw)) * cos(glm::radians(pitch));
		direction.z = sin(glm::radians(yaw));
		direction.y = sin(glm::radians(pitch)) * cos(glm::radians(pitch));
		Front = glm::normalize(direction);
		Right = glm::normalize(glm::cross(Front, WorldUp));
		Up = glm::normalize(glm::cross(Right, Front));


		ViewMatrix = glm::lookAt(
			Position,
			Position + Front,
			Up);
	}

}
