#pragma once
#include "Window.h"
#include "glfw/glfwWindow.h"
#include "Windows/win32Window.h"
namespace YoggieEngine {

    inline NativeWindow* CreateNativeWindow(int width, int height, const char* title) {
        spdlog::debug("CreateNativeWindow is called!");


        #ifdef PLATFORM_WINDOWS 
            spdlog::debug("PLATFROM_WINDOWS");
            return win32Window(width, height, title);
        #elseif PLATFORM_LINUX
            spdlog::debug("PLATFORM_LINUX");
            return X11Window(width, height, title);
        #else  
            spdlog::debug("PLATFORM_GLFW");
            return new glfwWindow(width, height, title);
        #endif

    }


}
