#pragma once 
#include "../EventSystem/Event.h"
#include "../EventSystem/EventListener.h"

namespace YoggieEngine {
    class NativeWindow  {
 
    public:
        NativeWindow() { spdlog::debug("NativeWindow Constructor called!"); }
        virtual bool WindowShouldClose() { return true; }

        virtual void SetViewPort(int width , int height) {}
        virtual void Poll() {}
        virtual void SwapBuffers() {}

        const int getWidth()const { return m_width; }
        const int getHeight()const { return m_height; }

        virtual void* GetHandle() { return m_handle;  }


    protected:
        virtual void SetContext() {}

        bool m_fullscreen = false;
        bool m_resizable = true;
        bool m_vsync = false;
        int m_width;
        int m_height;
        void* m_handle;

    };
}
